--- ./drivers/net/Space.c.ipsec	Thu Jun 11 22:59:33 1998
+++ ./drivers/net/Space.c	Thu Jun 25 11:14:49 1998
@@ -456,6 +456,40 @@
 #define	NEXT_DEV	(&fddi0_dev)
 #endif 
 
+#ifdef CONFIG_IPSEC
+extern int ipsec_tunnel_probe(struct device *);
+
+static struct device dev_ipsec1 = 
+{
+	"ipsec1\0   ",		/* name */
+	0,			/* recv memory end */
+	0,			/* recv memory start */
+	0,			/* memory end */
+	0,			/* memory start */
+ 	0x0,			/* base I/O address */
+	0,			/* IRQ */
+	0, 0, 0,		/* flags */
+	NEXT_DEV,		/* next device */
+	ipsec_tunnel_probe	/* setup */
+};
+
+static struct device dev_ipsec0 = 
+{
+	"ipsec0\0   ",		/* name */
+	0,			/* recv memory end */
+	0,			/* recv memory start */
+	0,			/* memory end */
+	0,			/* memory start */
+ 	0x0,			/* base I/O address */
+	0,			/* IRQ */
+	0, 0, 0,		/* flags */
+	&dev_ipsec1,		/* next device */
+	ipsec_tunnel_probe	/* setup */
+};
+#   undef	NEXT_DEV
+#   define	NEXT_DEV	(&dev_ipsec0)
+#endif /* CONFIG_IPSEC */
+
 #ifdef CONFIG_NET_IPIP
 	extern int tunnel_init(struct device *);
 	
