#include "internal.h"
#include "freeswan.h"

/*
 - subnetof - given address and mask, return subnet part
 */
struct in_addr
subnetof(addr, mask)
struct in_addr addr;
struct in_addr mask;
{
	struct in_addr result;

	result.s_addr = addr.s_addr & mask.s_addr;
	return result;
}

/*
 - hostof - given address and mask, return host part
 */
struct in_addr
hostof(addr, mask)
struct in_addr addr;
struct in_addr mask;
{
	struct in_addr result;

	result.s_addr = addr.s_addr & ~mask.s_addr;
	return result;
}

/*
 - broadcastof - given (network) address and mask, return broadcast address
 */
struct in_addr
broadcastof(addr, mask)
struct in_addr addr;
struct in_addr mask;
{
	struct in_addr result;

	result.s_addr = addr.s_addr | ~mask.s_addr;
	return result;
}
