/*
 * This program is an implementation of the ISAKMP Internet Standard.
 * This file is:
 * Copyright (C) 1998 D. Hugh Redelmeier
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 * This file was written while the author was in Canada.
 *
 * You may contact the author by e-mail: hugh@mimosa.com
 */

/* memory allocation */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <sys/types.h>

#include "constants.h"
#include "defs.h"
#include "log.h"

void *alloc_bytes(size_t size, const char *name)
{
	void *p = malloc(size);

	if (p == NULL)
		exit_log("unable to malloc %lu bytes for %s",
			(unsigned long) size, name);
	memset(p, '\0', size);
	return p;
}

void *clone_bytes(const void *orig, size_t size, const char *name)
{
	void *p = malloc(size);

	if (p == NULL)
		exit_log("unable to malloc %lu bytes for %s",
			(unsigned long) size, name);
	memcpy(p, orig, size);
	return p;
}
