/*
 * This program is an implementation of the ISAKMP Internet Standard.
 * This file is:
 * Copyright (C) 1998 D. Hugh Redelmeier
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 * This file was written while the author was in Canada.
 *
 * You may contact the author by e-mail: hugh@mimosa.com
 */

extern void ipsecdoi_initiate(
	int sock,
	struct sockaddr_in peer_sin,
	struct sockaddr_in our_client_net, struct sockaddr_in our_client_mask,
	struct sockaddr_in peer_client_net, struct sockaddr_in peer_client_mask,
	int goal,
	int protocol);

extern void main_inI1_outR1(
	int sock,
	struct sockaddr *sap,
	pb_stream *message,
	const struct isakmp_hdr *hdr);

struct state;	/* forward declaration of tag */

extern void init_phase2_iv(struct state *st);

/* status for state-transition-function */

typedef enum {
    STF_FAIL,	/* discard everything, we failed */
    STF_NO_REPLY,	/* success, but no reply to send */
    STF_REPLY	/* success, so send reply */
} stf_status;

typedef stf_status state_transition_fn(
    int sock,	/* socket for packet input/output */
    const struct sockaddr *sap,	/* network address */
    pb_stream *message,	/* message to be processed */
    const struct isakmp_hdr *hdr,	/* message's header */
    pb_stream *reply,	/* room for reply */
    struct state *st	/* current state object */
    );

extern state_transition_fn
    main_inR1_outI2,
    main_inR2_outI3,
    main_inI2_outR2,
    main_inI3_outR3,
    main_inR3,
    quick_inI1_outR1,
    quick_inR1_outI2,
    quick_inI2;
