/*
 * This program is an implementation of the ISAKMP Internet Standard.
 * This file is:
 * Copyright (C) 1998 D. Hugh Redelmeier
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 * This file was written while the author was in Canada.
 *
 * You may contact the author by e-mail: hugh@mimosa.com
 */

/* This file contains the declarations of routines that interface with
 * the kernel's IPsec mechanism.
 */

extern bool no_klips;	/* don't actually use KLIPS */

struct state;	/* "forward" declaration */
extern void get_ipsec_spi(u_char spi_out[IPSEC_DOI_SPI_SIZE]);

extern bool install_ipsec_sa(struct state *st, bool initiator);
extern bool delete_ipsec_sa(struct state *st, bool initiator);
